package ru.dbotthepony.kstarbound.defs

import com.google.gson.stream.JsonWriter
import ru.dbotthepony.kstarbound.io.json.IStringSerializable

enum class DamageType(private vararg val aliases: String) : IStringSerializable {
	NORMAL,
	IGNORE_DEFENCE("IGNORESDEF", "IGNOREDEF"),
	STATUS,
	NO_DAMAGE("NODAMAGE");

	override fun match(name: String): Boolean {
		for (alias in aliases)
			if (name == alias)
				return true

		return name == this.name
	}

	override fun write(out: JsonWriter) {
		out.value(this.name)
	}
}
